#include <iostream>
#include <dis.hxx>
using namespace std;
#include <string>
#include <nameParser.h>
#include <dabcRecords.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

class ErrorHandler : public DimErrorHandler
  {
    void errorHandler(int severity, int code, char *msg)
      {
        int index = 0;
        char **services;
        cout << "SRV: ERROR " << severity << " " << msg << endl;
        services = DimServer::getClientServices();
        cout<< "SRV: " << "from "<< DimServer::getClientName()<< " services:" << endl;
        while (services[index])
          {
            cout<< "SRV: " << services[index] << endl;
            index++;
          }
      }
public:
  ErrorHandler()
    {
      DimServer::addErrorHandler(this);
    }
  };

class ExitHandler : public DimExitHandler
  {
    void exitHandler(int code)
      {
        cout << "SRV: " << "exit code " << code << endl;
      }
public:
  ExitHandler()
    {
      DimServer::addExitHandler(this);
    }
  };

class CommandServer : public DimServer
  {
    DimCommand *cmd;
    char *cmdName;
    char *format;
    char pwdcrypt[14]; // encrypted password
    void commandHandler()
      {
        cmd = getCommand();
        cmdName=cmd->getName();
        format=cmd->getFormat();
        cout << "SRV: "<< "Command: " << cmdName << " f=" << format << " v=" ;
        if(*format == 'L')cout << cmd->getInt() ;
        if(*format == 'F')cout << cmd->getFloat() ;
        if(*format == 'C')cout << cmd->getString() ;
        cout << endl;
        // for convenience kill without password (from did):
        if(strstr(cmdName,"Exit")) exit(0);
        if(strstr(cmdName,"EXIT")) exit(0);

      }
public :
  CommandServer()
    {
      strcpy(pwdcrypt,"");
    }
  CommandServer(char *pwd)
    {
      strncpy(pwdcrypt, pwd, 13);
    }
  };


int main(int argc, char **argv)
  {
    char pwd[14];
    char *pwdcrypt;
    char servername[64];
    char nodename[64];
    char * colors[]={"Red","Green","Blue","Cyan","Yellow","Magenta"};
    ErrorHandler errHandler;
    ExitHandler *exHandler;
    DimCommand *servcom;
    CommandServer *comserv;
    DimService *servpar[1000];
    DimService *histo1,*histo2,*histo3,*comdef1,*comdef2;
    DimService *dimstate[120];
    DimService *diminfo[120];
    DimService *dimrate[120];
    dabcHistogram *his1,*his2,*his3;
    dabcState state[120];
    dabcInfo info[120];
    dabcRate rate[120];
    nameParser *pars;
    int numofserv;
    int *id1,*id2,*id3;
    int iPIDS[307];
    int iPMEM[307];
    int iPRUN[307];
    float fPTIM[307];
    int i,icol,inarr[1000],ipars;
    float flarr[1000];
    double xx,yy;
    char str[32];
    char line[256];
    char service[256];
    char setparcom[256];
    char format[256];
    char xmlcomdef1[512];
    char xmlcomdef2[512];
    if(argc < 3){
      cout << "ServerName PassWord" << endl;
      exit(0);
    }
    for(i=0;i<sizeof(inarr)/4;i++)
      {
        inarr[i]=0;
        flarr[i]=0;
      }

    numofserv=2; // number of rates, states, infos

    strcpy(str,"strini");
    strcpy(pwd, argv[2]);
    pwdcrypt=(char *)crypt(pwd,"x1");
    //strcpy(servername,"$");
    strcpy(servername,argv[1]);
    i=gethostname(nodename,64);
    if(argc > 3)numofserv=atol(argv[3]);
    cout << nodename << " SRV: "<< servername << " pwd: " << pwdcrypt << endl;
    pars=new nameParser();

    comserv = new CommandServer(pwdcrypt);
    exHandler=new ExitHandler();

    // define some structured record types
    his1=(dabcHistogram *)malloc(sizeof(dabcHistogram)+3996);
    his2=(dabcHistogram *)malloc(sizeof(dabcHistogram)+396);
    his3=(dabcHistogram *)malloc(sizeof(dabcHistogram)+76);
    strcpy(his1->cont,"his1");
    strcpy(his2->cont,"his2");
    strcpy(his3->cont,"his3");
    strcpy(his1->color,"Red");
    strcpy(his2->color,"Green");
    strcpy(his3->color,"White");
    strcpy(his1->xlett,"ax1");
    strcpy(his2->xlett,"ax2");
    strcpy(his3->xlett,"ax3");
    his1->channels=1000;
    his2->channels=100;
    his3->channels=20;
    his1->xlow=0;
    his1->xhigh=1000;
    his2->xlow=0;
    his2->xhigh=100;
    his3->xlow=0;
    his3->xhigh=20;
    pars->parseFullName("DABC/xi002:1972/TestRecords:42/Histo1");
    pars->setNodeName(nodename);
    sprintf(format,"%s:%d",HISTOGRAMDESC,1000);
    cout<<pars->buildFullName()<<endl;
    histo1 = new DimService(pars->buildFullName(),format,(void *)his1,sizeof(dabcHistogram)+3996);
    histo1->setQuality(pars->buildQuality(UPTODATE,HISTOGRAM,MONITOR,NOMODE));
    pars->setName("Histo2");
    cout<<pars->buildFullName()<<endl;
    sprintf(format,"%s:%d",HISTOGRAMDESC,100);
    histo2 = new DimService(pars->buildFullName(),format,(void *)his2,sizeof(dabcHistogram)+396);
    histo2->setQuality(pars->buildQuality(UPTODATE,HISTOGRAM,MONITOR,NOMODE));
    pars->setName("Histo3");
    cout<<pars->buildFullName()<<endl;
    sprintf(format,"%s:%d",HISTOGRAMDESC,20);
    histo3 = new DimService(pars->buildFullName(),format,(void *)his3,sizeof(dabcHistogram)+76);
    histo3->setQuality(pars->buildQuality(UPTODATE,HISTOGRAM,MONITOR,NOMODE));


    for(i=0;i<6;i++){rate[i].lower=0.0;rate[i].upper=0.0;}
    for(i=6;i<12;i++){rate[i].lower=0.0;rate[i].upper=2000.;}
    for(i=12;i<120;i++){rate[i].lower=0.0;rate[i].upper=4000.0;}
    icol=0;
    for(i=0;i<numofserv;i++){
      state[i].severity=0;
      sprintf(state[i].color,"Green");
      sprintf(state[i].status,"Text%03d",i+1);
      sprintf(str,"State%03d",i+1);
      pars->setName(str);
      cout<<pars->buildFullName()<<endl;
      dimstate[i]=new DimService(pars->buildFullName(),STATEDESC,(void *)&state[i],sizeof(dabcState));
      dimstate[i]->setQuality(pars->buildQuality(UPTODATE,STATE,MONITOR,NOMODE));
      info[i].mode=1;
      sprintf(info[i].color,"Green");
      sprintf(info[i].text,"Text message %03d",i+1);
      sprintf(str,"Info%03d",i+1);
      pars->setName(str);
      cout<<pars->buildFullName()<<endl;
      diminfo[i]=new DimService(pars->buildFullName(),INFODESC,(void *)&info[i],sizeof(dabcInfo));
      diminfo[i]->setQuality(pars->buildQuality(UPTODATE,INFO,MONITOR,NOMODE));
      strcpy(rate[i].color,colors[icol]);
      rate[i].displaymode=(icol+1)/2;
      rate[i].displaymode=2;
      rate[i].value=0;
      strcpy(rate[i].units,"MByte/s");
      sprintf(str,"Rate%03d",i+1);
      pars->setName(str);
      cout<<pars->buildFullName()<<endl;
      dimrate[i]=new DimService(pars->buildFullName(),RATEDESC,(void *)&rate[i],sizeof(dabcRate));
      dimrate[i]->setQuality(pars->buildQuality(UPTODATE,RATE,MONITOR,NOMODE));
      icol++;
      if(icol==6)icol=0;
    }

    comserv->start(nodename);
    cout<<"Start DIM server "<<nodename<<endl;

    int incr=50;
    int count=0;
    int inter = 0x40;
    int highwater=0;
    icol=0;
    while (1)
      {
        count++;
        if(icol<10){
          //sleep(1);
          sleep(1);
          if(highwater > 900)incr=-50;
          if(highwater < 2)incr=50;
          highwater += incr;
          sprintf(str,"str %08d %f",inarr[0],flarr[0]);
          id1=(int *)&his1->data;
          id2=(int *)&his2->data;
          id3=(int *)&his3->data;
          for(i=1;i<1000;i++){
            xx=(double)(i-inarr[0]);
            yy=(double)(i-1000+inarr[0]);
            *id1++ =(int)(1000.*exp(-xx*xx/4000.))+(int)(800.*exp(-yy*yy/112000.));
          }
          for(i=1;i<100;i++){
            xx=(double)(i-inarr[0]/10);
            yy=(double)(i-100+inarr[0]/10);
            *id2++ =(int)(100.*exp(-xx*xx/800.))+(int)(100.*exp(-yy*yy/1200.));
          }
          for(i=1;i<20;i++){
            xx=(double)(i-inarr[0]/100);
            yy=(double)(i-20+inarr[0]/100);
            *id3++ =(int)(20.*exp(-xx*xx/20.))+(int)(12.*exp(-yy*yy/40.));
          }
          inarr[0] += incr;
          histo1->updateService();
          histo2->updateService();
          histo3->updateService();
        for(i=0;i<numofserv;i++){
          rate[i].value = (float)highwater;
          dimrate[i]->updateService();
          sprintf(state[i].status,"%09d",count);
          strcpy(state[i].color,colors[icol]);
          dimstate[i]->updateService();
          sprintf(info[i].text,"Text %09d",count);
          strcpy(info[i].color,colors[icol]);
          diminfo[i]->updateService();
        }
      icol++;
      if(icol>1)icol=0;
    } // icol < 10
    } // while
    return 0;

  }

